//# SetOperations.h
//# Copyright (C) 2011-2013  ASTRON (Netherlands Institute for Radio Astronomy)
//# P.O. Box 2, 7990 AA Dwingeloo, The Netherlands
//#
//# This file is part of the LOFAR software suite.
//# The LOFAR software suite is free software: you can redistribute it and/or
//# modify it under the terms of the GNU General Public License as published
//# by the Free Software Foundation, either version 3 of the License, or
//# (at your option) any later version.
//#
//# The LOFAR software suite is distributed in the hope that it will be useful,
//# but WITHOUT ANY WARRANTY; without even the implied warranty of
//# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//# GNU General Public License for more details.
//#
//# You should have received a copy of the GNU General Public License along
//# with the LOFAR software suite. If not, see <http://www.gnu.org/licenses/>.
//#
//# $Id$

#ifndef LOFAR_INTERFACE_SET_OPERATIONS_H
#define LOFAR_INTERFACE_SET_OPERATIONS_H

#include <algorithm>

namespace LOFAR
{
  namespace Cobalt
  {

    template <typename T>
    T operator & (T a, T b)
    {
      sort(a.begin(), a.end());
      sort(b.begin(), b.end());

      T c(a.size() + b.size());
      c.resize(set_intersection(a.begin(), a.end(), b.begin(), b.end(), c.begin()) - c.begin());
      return c;
    }

    template <typename T>
    T operator | (T a, T b)
    {
      sort(a.begin(), a.end());
      sort(b.begin(), b.end());

      T c(a.size() + b.size());
      c.resize(set_union(a.begin(), a.end(), b.begin(), b.end(), c.begin()) - c.begin());
      return c;
    }

  } // namespace Cobalt
} // namespace LOFAR

#endif

